<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class crm20000EvolucaoCasoController extends SMCrud
{
    protected $dataSourceName = 'evolcont_contato';
    protected $entityManager;
    protected $connection;
    protected $newCode;
    protected $environment;

    public function __construct($crudService, $environment, $entityManager, $newCode) {
        parent::__construct($crudService, $environment);
        $this->entityManager = $entityManager;
        $this->newCode       = $newCode;
        $this->connection    = $entityManager->getConnection();
    }

    public function save(DTO\Request $request, DTO\Response $response){
        try {
            foreach($request->getDataSet()->getRows() as $row) {
                if (!property_exists($row, 'DTULTATU')) $row['DTULTATU'] = null;
                if (!property_exists($row, 'IDATIVO')) $row['IDATIVO']   = 'S';
                
                if ($row['__is_new'] && (!isset($row['NRSEQCONCLUSAO']))) {
                    if(empty($row['IDTPEVOLCONT'])) $row['IDTPEVOLCONT'] = 'P';
                    if(empty($row['NRRELACIONAPARC'])) $row['NRRELACIONAPARC'] = '';
                    if(empty($row['IDGERAFATURA'])) $row['IDGERAFATURA'] = 'NAO';
                    if(empty($row['IDANEXOEVOLCONT'])) $row['IDANEXOEVOLCONT'] = 'N';
                    if(empty($row['IDSENEVOCONT'])) $row['IDSENEVOCONT'] = 'S';
                    if(empty($row['NRSEQFILACONTA'])) $row['NRSEQFILACONTA'] = '';
                    if(empty($row['NRTERMOPORTUNI'])) $row['NRTERMOPORTUNI'] = '';
                    if(empty($row['CDOPEREVOL'])) $row['CDOPEREVOL'] = $this->environment->getCdOperador();
                    $row["CDFILIAL"] = $this->environment->getCdFilial();
                    $row['NRSEQEVOLCONT'] = $this->newCode->getCodeByTableName("EVOLCONT", $row["NRORG"]);
                    
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTINCLUSAO'] = date('d/m/y');
                    
                    $response->addDataSet(new DataSet("DADOS", array("NRSEQEVOLCONT" => $row["NRSEQEVOLCONT"], "DTINCLUSAO" => $row["DTINCLUSAO"])));
                } else {
                    date_default_timezone_set('America/Sao_Paulo');
                    $row['DTULTATU'] = date('d/m/y');
                    $response->addDataSet(new DataSet("DADOS", array("DTULTATU" => $row["DTULTATU"])));
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e){
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}