/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 2871_PEDSTPO_GERA_SUGCOMPRA_BDL.SQL                                        */
/* Autor: Diego Gonalves                                                     */
/* Data: 12/01/2010                                                           */
/* Descrio:                                                                 */
/*    Gerar sugesto para produtos da composio.                             */
/*----------------------------------------------------------------------------*/
create or replace
PROCEDURE GERA_SUGESTAO_COMPRA_BDL ( P_CDFILIAL     IN VARCHAR2,
                                     P_CDOPERADOR   IN VARCHAR2,
                                     P_DTPEDINI     IN DATE,
                                     P_DTPEDFIN     IN DATE,
                                     P_DTENTINI     IN DATE,
                                     P_DTENTFIN     IN DATE,
                                     P_IDSITITEMPED IN VARCHAR2,
                                     P_CDFILIDEST   IN VARCHAR2,
                                     P_CDCLIENTE    IN VARCHAR2,
                                     P_IDGERASOLCMP IN VARCHAR2,
                                     P_NRSUGCOMPRA  IN VARCHAR2,
                                     P_CDPRODINI    IN VARCHAR2,
                                     P_CDPRODFIN    IN VARCHAR2,
                                     P_DTENTSOLI    IN DATE,
                                     P_IDMENSSOLI  OUT PREVCOMP.NRPREVCOMP%TYPE)
AS
   V_NRITESUGCOMP NUMBER;
   V_QTCOMPRA     FLOAT;
   V_IDMENSSOLI   VARCHAR2(1);
   V_NRPREVCOMP   VARCHAR2(20);
   V_NRSEQPREVI   NUMBER;
   V_GEROU_SOLI   NUMBER;
   V_RETORNAFUNC  DOUBLE PRECISION;
BEGIN
   V_NRITESUGCOMP := 1;
   V_NRPREVCOMP := '';
   V_GEROU_SOLI := 0;

   FOR C_REG IN(
                SELECT I.CDPRODUTO, SUM(I.QTITEMPED - QTEXPITEMPED) QTITEMPED
                  FROM ITEMPEDIDO I, PEDIDO P, PRODUTO U
                 WHERE P.CDFILIAL =  P_CDFILIAL  
                   AND P.IDSITPEDIDO IN( '1','2','3','6') 
                   AND ((P.DTPEDIDO BETWEEN P_DTPEDINI  AND P_DTPEDFIN)OR((P_DTPEDINI IS NULL) AND(P_DTPEDFIN IS NULL)))
                   AND ((P_CDCLIENTE IS NULL)OR(INSTR(P_CDCLIENTE, P.CDCLIENTE)>0))
                   AND ((P_CDFILIDEST IS NULL)OR( INSTR(P_CDFILIDEST, P.CDFILIALPED)>0))
                   AND (( TRUNC(I.DTENTITPED)BETWEEN P_DTENTINI  AND P_DTENTFIN)OR((P_DTENTINI IS NULL) AND(P_DTENTFIN IS NULL)))
                   AND (INSTR( P_IDSITITEMPED, IDSITITEMPED) >0)
                   AND U.CDARVPROD BETWEEN P_CDPRODINI AND P_CDPRODFIN 
                   AND I.CDFILIAL =  P.CDFILIAL 
                   AND I.NRPEDIDO =  P.NRPEDIDO 
                   AND I.CDPRODUTO = U.CDPRODUTO 
                   AND NOT EXISTS( SELECT K.NRPEDIDO
                                     FROM PEDIDOP K
                                    WHERE K.CDFILIAL = I.CDFILIAL 
                                      AND K.NRPEDIDO = I.NRPEDIDO 
                                      AND K.NRITEMPED = I.NRITEMPED)
                 GROUP BY I.CDPRODUTO
   )LOOP

      GRAVA_COMPOSICAO_BDL (P_CDFILIAL, C_REG.CDPRODUTO, C_REG.QTITEMPED, SYSDATE,
                            P_NRSUGCOMPRA, P_DTENTINI, P_DTENTFIN, P_DTPEDFIN, P_DTPEDINI, P_CDFILIDEST, P_CDCLIENTE, P_IDSITITEMPED);


   END LOOP;

   IF P_IDGERASOLCMP  = 'S' THEN
      P_IDMENSSOLI := '';
      FOR C IN(
               SELECT CDFILSUGCOMP, NRSUGCOMPRA, CDPROSUGCOMP,
                      DTREFSUGCOMP, QTCOMPRA, QTSAIDAANT01,
                      QTSAIDAANT02, QTSAIDAANT03, QTSAIDAATUAL, QTMEDIAMES, NRITESUGCOMP
               FROM  TRAB_SUGCOMPRA
               WHERE CDFILSUGCOMP = P_CDFILIAL 
                 AND NRSUGCOMPRA  = P_NRSUGCOMPRA 
                 AND QTCOMPRA > 0
      )LOOP
         IF V_GEROU_SOLI = 0 THEN
            NOVO_CODIGO('NRPREVCOMP'||P_CDFILIAL, V_NRPREVCOMP, 1);
            V_NRPREVCOMP := SUBSTR(V_NRPREVCOMP, 11, 10);

            INSERT INTO PREVCOMP
               (CDFILIAL, NRPREVCOMP, CDOPGERPRCOM, DTHRPREVCOMP, IDSTPREVCOMP)
            VALUES
               (P_CDFILIAL, V_NRPREVCOMP, P_CDOPERADOR, SYSDATE, 'P');
            V_GEROU_SOLI := 1;
         END IF;

         SELECT
            NVL(MAX(NRITPREVCOMP), 0) + 1
         INTO
            V_NRSEQPREVI
         FROM
            ITPREVCOMP
         WHERE
            CDFILIAL   = P_CDFILIAL    AND
            NRPREVCOMP = V_NRPREVCOMP;

         INSERT INTO ITPREVCOMP
            (CDFILIAL, NRPREVCOMP, NRITPREVCOMP, CDPRODUTO,  DTENTPRECOMP, QTPREVCOMP)
         VALUES
            (P_CDFILIAL, V_NRPREVCOMP , LPAD(TO_CHAR(V_NRSEQPREVI), 4, '0'), C.CDPROSUGCOMP, P_DTENTSOLI, C.QTCOMPRA);

      END LOOP;

      DELETE FROM  TRAB_SUGCOMPRA
      WHERE CDFILSUGCOMP = P_CDFILIAL 
        AND NRSUGCOMPRA  = P_NRSUGCOMPRA;

      IF V_GEROU_SOLI = 1 THEN
         P_IDMENSSOLI := V_NRPREVCOMP;
      ELSE
         P_IDMENSSOLI := '3';
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_SUGESTAO_COMPRA_BDL','5.09.014'); END;
/
